#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl.H>
#include <FL/Fl_Native_File_Chooser.H>
#include <FL/Fl_File_Chooser.H>

Fl_Choice *choice;

class track : public Fl_Box {
public:
  track(int x, int y, int w, int h) : Fl_Box(x,y,w,h,"") {
    
  }
  int handle(int event) {
    if (event == FL_PUSH) {
      char txt[50];
      sprintf(txt, "Fl::event_ctrl()=%d", Fl::event_ctrl());
      copy_label(txt);
      redraw();
      return 1;
    }
    else if (event == FL_FOCUS) {
      return 1;
    }
    else if (event == FL_KEYBOARD && Fl::event_ctrl() && Fl::event_key('O')) {
      if (choice->value() == 0) {
        Fl_Native_File_Chooser *chooser = new Fl_Native_File_Chooser();
        chooser->show();
        delete chooser;
      }
      else {
        Fl_File_Chooser *chooser = new Fl_File_Chooser("", NULL, 0, "");
        chooser->show();
        while (chooser->shown()) Fl::wait();
        delete chooser;
      }
    return 1;
    }
    return 0;
  }
};

int main(void)
{
  Fl_Window *win = new Fl_Window(200,220);
  track *t = new track(0,0,200,200);
  choice = new Fl_Choice(00,200,200,20);
  choice->add("Fl_Native_File_Chooser");
  choice->add("Fl_File_Chooser");
  choice->value(0);
  win->end();
  win->resizable(win);
  win->show();
  Fl::focus(t);
  while (Fl::first_window()) {
    Fl::wait();
    Fl::focus(t);
  }
  return 0;
}
